#!/bin/bash
#Script just put commands into file that can be used as a shell programm to encode video and make ScreenShots
#Done like this because ffmpeg always breaks the while cycle
#----------------------------------------------------------

#Variables:
#path and name of generated file
ConvertTaskFileName=~/ConvertTask.sh
audioRate=22050
audioBitRate=64k
thumbSS=100x75
sstime=07
audioCodec=libmp3lame
#----------------------------------------------------------

if [[ ! -f $ConvertTaskFileName ]]; then
echo "#!/bin/bash" > $ConvertTaskFileName
chmod u+x $ConvertTaskFileName
fi

FullFileName=$1
#Get File name, dir and extension (in this version we don't need extension)
dir=$(dirname $FullFileName)
filename=$(basename $FullFileName)
extension=${filename##*.}
filename=${filename%.*}
#Encode to Flv our video files
echo "ffmpeg -y -i ${FullFileName} \
-acodec ${audioCodec} \
-ar ${audioRate} \
-ab ${audioBitRate} \
-f flv \
-sameq ${dir}/${filename}.flv"  >> $ConvertTaskFileName
#make a thumb ScreenShot. In my case it's 100x75 pixels
echo "ffmpeg -i ${dir}/${filename}.flv -an -ss 00:00:${sstime} \
-r 1 -vframes 1 \
-s ${thumbSS} -y ${dir}/thumb_${filename}.jpg"  >> $ConvertTaskFileName
#make normal screenShots. In my case it's the same as video width x height so I don't need to convert it to JW Player's size
echo "ffmpeg -i ${dir}/${filename}.flv -an -ss 00:00:${sstime} \
-r 1 -vframes 1 -y ${dir}/normal_${filename}.jpg"  >> $ConvertTaskFileName