<?php
/**************************************************
  Coppermine 1.5.x Plugin - video2flash_ffmpeg
  *************************************************
  Copyright (c) 2010 Abbas Ali
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  ********************************************
  $HeadURL: https://coppermine.svn.sourceforge.net/svnroot/coppermine/branches/cpg1.5.x/plugins/video2flash_ffmpeg/codebase.php $
  $Revision: 7119 $
  $LastChangedBy: gaugau $
  $Date: 2010-01-24 21:39:28 +0100 (So, 24 Jan 2010) $
  **************************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Add an install action
$thisplugin->add_action('plugin_install', 'video2flash_ffmpeg_install');

// Add a configure action
$thisplugin->add_action('plugin_configure', 'video2flash_ffmpeg_configure');

// Add an uninstall action
$thisplugin->add_action('plugin_uninstall','video2flash_ffmpeg_uninstall');

// Add a filter for file upload. This filter is called after the file is successfully uploaded and right before a new image's data is written to the database
$thisplugin->add_filter('add_file_data', 'video2flash_ffmpeg_add_file_data');

// Add a filter for displaying the flv player on display image page
$thisplugin->add_filter('file_data', 'video2flash_ffmpeg_file_data');

// Add a action for file delete. When a file is deleted then its thumb should also be deleted
$thisplugin->add_action('after_delete_file', 'video2flash_ffmpeg_delete_file');

global $video2flash_ffmpeg_configs;
$video2flash_ffmpeg_configs = array('video2flash_ffmpeg_ffmpeg_path', 'video2flash_ffmpeg_player_width', 'video2flash_ffmpeg_player_height', 'video2flash_ffmpeg_player_autostart', 'video2flash_ffmpeg_thumb_interval', 'video2flash_ffmpeg_player_controlbar', 'video2flash_ffmpeg_player_skin', 'video2flash_ffmpeg_audio_codec', 'video2flash_ffmpeg_audio_discr', 'video2flash_ffmpeg_audio_bitrate');

// Install function
// Inserts the config variables in cpg_config table
function video2flash_ffmpeg_install() {
    global $CONFIG, $video2flash_ffmpeg_configs;
    $superCage   = Inspekt::makeSuperCage();
    // Install
    if ($superCage->post->keyExists('video2flash_ffmpeg_ffmpeg_path') && trim($superCage->post->getEscaped('video2flash_ffmpeg_ffmpeg_path'))) {
        foreach ($video2flash_ffmpeg_configs as $config_name) {
            $config_value = trim($superCage->post->getEscaped($config_name));
            // If this is the time interval and is a single digit then add 0 in front of it
            if ($config_name == 'video2flash_ffmpeg_thumb_interval' && strlen($config_value) == 1) {
                $config_value = '0' . $config_value;
            }
            // Run the query to put a config variable for ffmpeg path
            if ($config_value) {
                $query = "REPLACE INTO {$CONFIG['TABLE_CONFIG']} SET name = '$config_name', value = '$config_value'";
                cpg_db_query($query);
            }
        }
        return true;

    // Loop again
    } else {

        return 1;
    }
}
//Generates Select list HTML code for changing skins
function video2flash_ffmpeg_GenSkinSelectList()
{
	global $CONFIG;
	$dir = "plugins/video2flash_ffmpeg/skin";
	$files = scandir($dir);
	foreach ($files as $key => $val)
		if(is_dir($val) )
			unset($files[$key]);

	if (!isset($CONFIG['video2flash_ffmpeg_player_skin']))
		$CONFIG['video2flash_ffmpeg_player_skin'] = 'glow.zip';

	//Generate form select list	
	$select_list = '<select size="3" style="width:50%;" class="textinput" name="video2flash_ffmpeg_player_skin">'."\n";
	if(count($files) != 0 )
		foreach ($files as $key => $val)
			if($val == $CONFIG['video2flash_ffmpeg_player_skin'] )
				$select_list .= "\t".'<option selected="yes" value="'.$val.'">'.$val.'</option>'."\n";
			else
				$select_list .= "\t".'<option value="'.$val.'">'.$val.'</option>'."\n";
	else
		$select_list .= "\t".'<option value="none">No skins were found</option>'."\n";
	$select_list .='</select>';
	return $select_list;

}


// Configure function
// Displays the form
function video2flash_ffmpeg_configure() {
    global $CONFIG;
	//Set audion discritization
    if (!isset($CONFIG['video2flash_ffmpeg_audio_discr'])) {
        $CONFIG['video2flash_ffmpeg_audio_discr'] = 22050;
    }
	
	//Set audion bit rate
    if (!isset($CONFIG['video2flash_ffmpeg_audio_bitrate'])) {
        $CONFIG['video2flash_ffmpeg_audio_bitrate'] = '64k';
    }

	//Codec to encode audio
    $codec_mp3 = '';
    $codec_libmp3lame = '';
    if (!isset($CONFIG['video2flash_ffmpeg_audio_codec']) || $CONFIG['video2flash_ffmpeg_audio_codec'] == 'mp3')
        $codec_mp3 = ' checked="checked" ';
	else
        $codec_libmp3lame = ' checked="checked" ';
	

	//Player width
    if (!isset($CONFIG['video2flash_ffmpeg_player_width'])) {
        $CONFIG['video2flash_ffmpeg_player_width'] = 534;
    }
    //Player height
    if (!isset($CONFIG['video2flash_ffmpeg_player_height'])) {
        $CONFIG['video2flash_ffmpeg_player_height'] = 400;
    }
    //Interval to take ScreenShots for previews while adding new video and encoding it to flv.
    if (!isset($CONFIG['video2flash_ffmpeg_thumb_interval'])) {
        $CONFIG['video2flash_ffmpeg_thumb_interval'] = 3;
    }   
	//Start player automaticly: yes or no
    $autostart_yes = '';
    $autostart_no = '';
    if (!isset($CONFIG['video2flash_ffmpeg_player_autostart']) || $CONFIG['video2flash_ffmpeg_player_autostart'] == 'no')
        $autostart_no = ' checked="checked"';
	else
        $autostart_yes = ' checked="checked"';
	
	//Position of Control bar
	$control_bar_position = array("bottom" => "", "top" => "", "over" => "", "none" => "");
    if (!isset($CONFIG['video2flash_ffmpeg_player_controlbar']) || $CONFIG['video2flash_ffmpeg_player_controlbar'] == '' )
        $control_bar_position["bottom"] = ' checked="checked" ';
	else
		 $control_bar_position[$CONFIG['video2flash_ffmpeg_player_controlbar']] = ' checked="checked" ';

    //Get Skin Select list HTML code
	$skin_select_list = video2flash_ffmpeg_GenSkinSelectList();
	
    echo <<< EOT
    <form name="cpgform" id="cpgform" action="{$_SERVER['REQUEST_URI']}" method="post">
            <table border="0" cellspacing="0" cellpadding="0" width="100%">
              <tr>
                <th class="tableb" align="center" colspan="2">
                  Technical parameters
                </th>
              </tr>
              <tr>
                <td class="tableb" align="right" width="250">
                  Absolute path to ffmpeg binary:
                </td>
                <td class="tableb">
                  <input type="text" name="video2flash_ffmpeg_ffmpeg_path" class="textinput" style="width:50%;" value="{$CONFIG['video2flash_ffmpeg_ffmpeg_path']}" />
                </td>
              </tr>
			  
              <tr>
                <td class="tableb" align="right" width="250">
                  Width of the FLV player:
                </td>
                <td class="tableb">
                  <input type="text" name="video2flash_ffmpeg_player_width" class="textinput" size="3" value="{$CONFIG['video2flash_ffmpeg_player_width']}" />
                </td>
              </tr>
              <tr>
                <td class="tableb" align="right" width="250">
                  Height of the FLV Player:
                </td>
                <td class="tableb">
                  <input type="text" name="video2flash_ffmpeg_player_height" class="textinput" size="3" value="{$CONFIG['video2flash_ffmpeg_player_height']}" />
                </td>
              </tr>
              <tr>
                <td class="tableb" align="right" width="250">
                  Thumb extraction interval in seconds (< 60):
                </td>
                <td class="tableb">
                  <input type="text" name="video2flash_ffmpeg_thumb_interval" class="textinput" size="3" value="{$CONFIG['video2flash_ffmpeg_thumb_interval']}" />
                </td>
              </tr>
			  
              <tr>
                <td class="tableb" align="right" width="250">
                  Audio discretization rate:
                </td>
                <td class="tableb">
                  <input type="text" name="video2flash_ffmpeg_audio_discr" class="textinput" size="5" value="{$CONFIG['video2flash_ffmpeg_audio_discr']}" />
                </td>
              </tr>
			  
              <tr>
                <td class="tableb" align="right" width="250">
                  Audio bit rate:
                </td>
                <td class="tableb">
                  <input type="text" name="video2flash_ffmpeg_audio_bitrate" class="textinput" size="5" value="{$CONFIG['video2flash_ffmpeg_audio_bitrate']}" />
                </td>
              </tr>

              <tr>
                <td class="tableb" align="right" width="250">
                  Choose audio encoding method:
                </td>
                <td class="tableb">
                  <input type="radio" id="codec_mp3" name="video2flash_ffmpeg_audio_codec" class="radio" {$codec_mp3} value="mp3"/>
                  <label for="codec_mp3">mp3</label>
                  &nbsp;&nbsp;
                  <input type="radio" id="codec_libmp3lame" name="video2flash_ffmpeg_audio_codec" class="radio" value="libmp3lame" {$codec_libmp3lame} />
                  <label for="codec_libmp3lame">libmp3lame</label>
                </td>
              </tr>			  
			  
              <tr>
                <th class="tableb" align="center" colspan="2">
					Displaying options
                </th>
              </tr>
			  
              <tr>
                <td class="tableb" align="right" width="250">
                  Select JW Player Skin:
                </td>
                <td class="tableb">
					{$skin_select_list}
                </td>
              </tr> 
			 
              <tr>
                <td class="tableb" align="right" width="250">
                  Automatically start the player on load:
                </td>
                <td class="tableb">
                  <input type="radio" id="autostart_yes" name="video2flash_ffmpeg_player_autostart" class="radio" {$autostart_yes} value="yes"/>
                  <label for="autostart_yes">Yes</label>
                  &nbsp;&nbsp;
                  <input type="radio" id="autostart_no" name="video2flash_ffmpeg_player_autostart" class="radio" value="no" {$autostart_no} />
                  <label for="autostart_no">No</label>
                </td>
              </tr>
			  
              <tr>
                <td class="tableb" align="right" width="250">
                  Control Bar Position:
                </td>
                <td class="tableb">
                  <input type="radio" id="control_bar_bottom" name="video2flash_ffmpeg_player_controlbar" class="radio" {$control_bar_position['bottom']} value="bottom"/>
                  <label for="control_bar_bottom">bottom</label>
                  &nbsp;&nbsp;
				  
                  <input type="radio" id="control_bar_top" name="video2flash_ffmpeg_player_controlbar" class="radio" {$control_bar_position['top']} value="top"/>
                  <label for="control_bar_top">top</label>
                  &nbsp;&nbsp;				  
				  
                  <input type="radio" id="control_bar_over" name="video2flash_ffmpeg_player_controlbar" class="radio" {$control_bar_position['over']} value="over"/>
                  <label for="control_bar_over">over</label>
                  &nbsp;&nbsp;	
			  
                  <input type="radio" id="control_bar_none" name="video2flash_ffmpeg_player_controlbar" class="radio" value="none" {$control_bar_position['none']} />
                  <label for="control_bar_none">none</label>
                </td>
              </tr>
			  
              <tr>
                <td class="tablef" colspan="2">
                  <input type="submit" value="Go!" class="button" />
                </td>
              </tr>
            </table>
    </form>
EOT;
}

/**
 * Function called when the plugin is uninstalled
 * 
 * We will delete the plugin related config values from db
 */
function video2flash_ffmpeg_uninstall() {
    global $CONFIG, $video2flash_ffmpeg_configs;
    // Delete the video plugin related config values
    foreach ($video2flash_ffmpeg_configs as $name) {
        $f = cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE `name` = '$name'");
    }
    return true;
}

/**
 * This function is called after the file is successfully uploaded and before it was added to db
 * This function will create the video thumb
 */
function video2flash_ffmpeg_add_file_data($pic_data) {
    global $CONFIG;
    $filepath = $pic_data['filepath'];
    $filename = $pic_data['filename'];
    $image = $CONFIG['fullpath'] . $filepath . $filename;
    if (is_movie($image)) {
        preg_match("/(.+)\.(.*?)\Z/", $filename, $matches);
        $thumb = $CONFIG['fullpath'] . $filepath . $CONFIG['thumb_pfx'] . $matches[1].".jpg";
        $normal = $CONFIG['fullpath'] . $filepath . $CONFIG['normal_pfx'] . $matches[1].".jpg";
        $flv = $CONFIG['fullpath'] . $filepath . $matches[1].".flv";
        $videoThumb = create_movie_thumb($image);
        $tmpFlv = convert_to_flv($image);
        // If we have the flv file
        if ($tmpFlv) {
            // move it to the final location
            rename($tmpFlv, $flv);
            // Add the fileszie of flv to total filesize
            $pic_data['total_filesize'] += filesize($flv);
        }
        $imagesize = getimagesize($videoThumb);
        if ($videoThumb) {
            if (!resize_image($videoThumb, $thumb, $CONFIG['thumb_width'], $CONFIG['thumb_method'], $CONFIG['thumb_use'])) {
                // If resize fails then we are not doing anything as the file is already uploaded and if no video thumb is created then nothing should be done.
            } else {
                // Also create a normal size image to show as a preview in flash player
                if (resize_image($videoThumb, $normal, $CONFIG['video2flash_ffmpeg_player_width'], $CONFIG['thumb_method'], $CONFIG['thumb_use'])) {
                    // Add the filesize of normal to the total filesize
                    $pic_data['total_filesize'] += filesize($normal);
                }
                $pic_data['pwidth'] = $imagesize[0];
                $pic_data['pheight'] = $imagesize[1];
                $pic_data['total_filesize'] += filesize($thumb);
            }
            @unlink($videoThumb);
        } else {
            // If video thumb is not created then proceed and don't stop here. We are not stopping as the file is already uploaded.
        }
    }

    return $pic_data;
}

/**
 * Function to delete thumb and flv of the video
 */
function video2flash_ffmpeg_delete_file($pic) {
    global $CONFIG;
    $file = $CONFIG['fullpath'] . $pic['filepath'] . $pic['filename'];
    preg_match("/(.+)\.(.*?)\Z/", $pic['filename'], $matches);
    $thumb = $CONFIG['fullpath'] . $pic['filepath'] . $CONFIG['thumb_pfx'] . $matches[1].".jpg";
    $normal = $CONFIG['fullpath'] . $pic['filepath'] . $CONFIG['normal_pfx'] . $matches[1].".jpg";
    $flv = $CONFIG['fullpath'] . $pic['filepath'] . $matches[1].".flv";

    @unlink($thumb);
    @unlink($normal);
    @unlink($flv);
}

/**
 * Function to return html required for displaying the flv palyer
 */
function video2flash_ffmpeg_file_data($pic_data) {
    global $CONFIG;

    $file = $CONFIG['fullpath'] . $pic_data['filepath'] . $pic_data['filename'];
    $picture_url = get_pic_url($pic_data, 'fullsize');

    preg_match("/(.+)\.(.*?)\Z/", $pic_data['filename'], $matches);
    $flv = $CONFIG['fullpath'] . $pic_data['filepath'] . $matches[1] . '.flv';

    // We will replace the file html only if it is a valid movie and we have the flv file
    if (is_movie($file) && file_exists($flv)) {
		$normal = $CONFIG['fullpath'] . $pic_data['filepath'] . $CONFIG['normal_pfx'] . $matches[1].".jpg";
		
		$flashvars = 'file='.$CONFIG['ecards_more_pic_target'].$flv;
		$flashvars .= '&id=player1'; //Id of player
		//Viral Plugin. For more info see  http://www.longtailvideo.com/support/forums/addons/using-and-creating-skins/10040/how-to-disable-embed-share
		$flashvars .= '&viral.onpause=false'; //Show menu on pause button press or not
		$flashvars .= '&viral.oncomplete=false';//Show menu video oncompleted playing
		$flashvars .= '&viral.allowmenu=true';//shows viral menu button
		$flashvars .= '&viral.functions=all';//Viral functions
		$flashvars .= '&stretching=uniform'; //stretch the image/video while maintaining its aspect ratio. Borders will appear around the image/video.
		
		//BackGround Image
        if (file_exists($normal) )
            $flashvars .= '&image=' . $CONFIG['ecards_more_pic_target'] . $normal;
		//Autostart
        if ($CONFIG['video2flash_ffmpeg_player_autostart'] == 'yes')
            $flashvars .= '&autostart=true';

		//Control position
        $flashvars .= '&controlbar='.$CONFIG['video2flash_ffmpeg_player_controlbar'];

		//Skin for player
		$skin_path = 'plugins/video2flash_ffmpeg/skin/'.$CONFIG['video2flash_ffmpeg_player_skin'];
		if (file_exists($skin_path) )
			$flashvars .= '&skin='.$skin_path;


		
		
		$pic_data['html'] = '		
		<object
			type="application/x-shockwave-flash"
			data="plugins/video2flash_ffmpeg/player.swf"
			width="'.$CONFIG['video2flash_ffmpeg_player_width'].'"
			height="'.$CONFIG['video2flash_ffmpeg_player_height'].'"
			id="player1"
			name="player1"
			codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0"
			>';
		$pic_data['html'] .= "\n\t".'<param name="quality" value="best" />';
		$pic_data['html'] .= "\n\t".'<param name="allowfullscreen" value="true">';
		$pic_data['html'] .= "\n\t".'<param name="allowscriptaccess" value="always">';
		$pic_data['html'] .= "\n\t".'<param name="wmode" value="opaque">';
		$pic_data['html'] .= "\n\t".'<param name="flashvars" value="'.$flashvars.'">';

		$pic_data['html'] .= "\n\t".'
			<embed
				type="application/x-shockwave-flash"
				id="player1"
				name="player1"
				src="plugins/video2flash_ffmpeg/player.swf" 
				width="'.$CONFIG['video2flash_ffmpeg_player_width'].'"
				height="'.$CONFIG['video2flash_ffmpeg_player_height'].'"
				allowscriptaccess="always" 
				allowfullscreen="true"
				wmode="opaque"
				pluginspage="http://www.macromedia.com/go/getflashplayer"
				flashvars="'.$flashvars.'" 
			/>'."\n".'
		</object>';

    }
  //  print_r($pic_data);
    return $pic_data;
}

/**
 * Function to create video thumbnail using ffmpeg
 */
function create_movie_thumb($src_file) {
    global $CONFIG;

    $dest_file = $CONFIG['fullpath'] . "edit/" . md5(uniqid(time()))."%d.jpg";

    if (preg_match("#[A-Z]:|\\\\#Ai", __FILE__)) {
        // get the basedir, remove '/include'
        $cur_dir = substr(dirname(__FILE__), 0, -8);
        $src_file = '"' . $cur_dir . '\\' . strtr($src_file, '/', '\\') . '"';
        $ff_dest_file = '"' . $cur_dir . '\\' . strtr($dest_file, '/', '\\') . '"';
    } else {
        $src_file = escapeshellarg($src_file);
        $ff_dest_file = escapeshellarg($dest_file);
    }

    $output = array();

    if (eregi("win", $_ENV['OS'])) {
        // Command to create video thumb
        $cmd = "\"".str_replace("\\","/", $CONFIG['video2flash_ffmpeg_ffmpeg_path'])."\" -i ".str_replace("\\","/" ,$src_file )." -an -ss 00:00:{$CONFIG['video2flash_ffmpeg_thumb_interval']} -r 1 -vframes 1 -y ".str_replace("\\","/" ,$ff_dest_file);
        exec ("\"$cmd\"", $output, $retval);
    } else {
        // Command to create video thumb
        $cmd = "{$CONFIG['video2flash_ffmpeg_ffmpeg_path']} -i $src_file -an -ss 00:00:{$CONFIG['video2flash_ffmpeg_thumb_interval']} -r 1 -vframes 1 -y $ff_dest_file";
        exec ($cmd, $output, $retval);
    }


    if ($retval) {
        @unlink($dest_file);
        return false;
    }

    $return = str_replace("%d", "1", $dest_file);
    @chmod($return, octdec($CONFIG['default_file_mode'])); //silence the output in case chmod is disabled
    return $return;
}

/**
 * Function to convert video to flv using ffmpeg
 */
function convert_to_flv($src_file) {
    global $CONFIG;

    $dest_file = $CONFIG['fullpath'] . "edit/" . md5(uniqid(time())).".flv";

    if (preg_match("#[A-Z]:|\\\\#Ai", __FILE__)) {
        // get the basedir, remove '/include'
        $cur_dir = substr(dirname(__FILE__), 0, -8);
        $src_file = '"' . $cur_dir . '\\' . strtr($src_file, '/', '\\') . '"';
        $ff_dest_file = '"' . $cur_dir . '\\' . strtr($dest_file, '/', '\\') . '"';
    } else {
        $src_file = escapeshellarg($src_file);
        $ff_dest_file = escapeshellarg($dest_file);
    }

    $output = array();

    if (eregi("win", $_ENV['OS'])) {
        // Command to create video thumb in Win OS
        $cmd = "\"".str_replace("\\","/", $CONFIG['video2flash_ffmpeg_ffmpeg_path'])."\" -y -i ".str_replace("\\","/" ,$src_file )." -acodec {$CONFIG['video2flash_ffmpeg_audio_codec']} -ar {$CONFIG['video2flash_ffmpeg_audio_discr']} -ab {$CONFIG['video2flash_ffmpeg_audio_bitrate']} -f flv -sameq ".str_replace("\\","/" ,$ff_dest_file);
        exec ("\"$cmd\"", $output, $retval);
    } else {
        // Command to create video thumb in Unix like OS
        $cmd = "{$CONFIG['video2flash_ffmpeg_ffmpeg_path']} -y -i $src_file -acodec {$CONFIG['video2flash_ffmpeg_audio_codec']} -ar {$CONFIG['video2flash_ffmpeg_audio_discr']} -ab {$CONFIG['video2flash_ffmpeg_audio_bitrate']} -f flv -sameq $ff_dest_file";
        exec ($cmd, $output, $retval);
    }


    if ($retval) {
        @unlink($dest_file);
        return false;
    }

    $return = $dest_file;
    @chmod($return, octdec($CONFIG['default_file_mode'])); //silence the output in case chmod is disabled
    return $return;
}
?>
